package w2phtml.pageSplitters;

import static w2phtml.office.XMLString.TEXT_ALPHABETICAL_INDEX_SOURCE;
import static w2phtml.office.XMLString.TEXT_INDEX_BODY;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import w2phtml.office.OfficeReader;

public class ABIndexSplitter extends BasicSplitter implements ISplitter {

	public ABIndexSplitter(OfficeReader officeReader, SplitFactory factory) {
		super(officeReader, factory);
	}

	@Override
	public boolean Split(Node abIndex) {
		Node parent = abIndex.getParentNode();
		Node abIndexFirstPart = abIndex.cloneNode(false);
		NodeList childs = abIndex.getChildNodes();
		boolean dataMoved = false;
		int i = 0;
		while (childs.getLength() > i) {
			Node child = childs.item(i);
			String childName = child.getNodeName();
			if (childName.equals(TEXT_ALPHABETICAL_INDEX_SOURCE)) {
				abIndexFirstPart.appendChild(child.cloneNode(true));
			} else
			if (childName.equals(TEXT_INDEX_BODY)) {
				if (factory.split(child)) {
					abIndexFirstPart.appendChild(child.getPreviousSibling());
					dataMoved = true;
				}
			}
			i++;
		}
		if (dataMoved) {
			parent.insertBefore(abIndexFirstPart, abIndex);
		}	
		return dataMoved;
	}

}
